package f5

import (
	"q5"
	"github.com/gin-gonic/gin"
)

const (
	WSPROXYPACKHEAD_C_SIZE = 24
	WSPROXYPACKHEAD_S_SIZE = 16
	NET_MSG_MAGIC_CODE     = uint16('K') + uint16('S')<<8
)

type MsgNode struct {
}

type IMMsgNode struct {
	msgId  uint16
	params q5.Args
	next   *IMMsgNode
}

type Pagination struct {
	Total       int32
	PerPage     int32
	CurrentPage int32
	TotalPages  int32
	Rows        *DataSet
}

type StreamPagination struct {
	NextCursor int64
	PreviousCursor int64
	Remaining int32
	Count int32
	TotalCount int32
}

type GinHandlerFunc func(*gin.Context)

type QueryResultCb func(error, *DataSet)
type QueryOneCb func(error, *DataSet)
type PageQueryCb func(error, *Pagination)
type SteamPageQueryCb func(error, *StreamPagination)
type ExecResultCb func(error, int64, int64)
